import{S as yt,i as wt,s as Tt,e as n,k as c,w as fe,t as r,M as _t,c as l,d as t,m as d,a as s,x as he,h as i,b as p,G as a,g as m,y as ue,L as bt,q as ge,o as ve,B as ye,v as Pt}from"../../chunks/vendor-hf-doc-builder.js";import{I as gt}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as vt}from"../../chunks/CodeBlock-hf-doc-builder.js";function Mt(Xe){let g,Z,v,w,V,P,we,z,Te,X,y,T,x,M,_e,F,be,j,_,Pe,E,Me,Ee,Y,L,Ge,Q,B,H,Ae,K,J,ke,ee,b,$e,G,Oe,Ce,te,f,Ne,A,Le,Be,k,Je,Re,ae,R,Se,oe,$,ne,S,We,re,h,Ie,q,Ue,Ve,D,ze,xe,le,O,ie,u,Fe,C,He,qe,N,De,Ze,se;return P=new gt({}),M=new gt({}),$=new vt({props:{code:"d2dldCUyMC0tY29udGVudC1kaXNwb3NpdGlvbiUyMGh0dHBzJTNBJTJGJTJGYXBpLm5nYy5udmlkaWEuY29tJTJGdjIlMkZtb2RlbHMlMkZudmlkaWElMkZtZWdhdHJvbl9sbV8zNDVtJTJGdmVyc2lvbnMlMkZ2MC4wJTJGemlwJTIwLU8lMEFtZWdhdHJvbl9ncHQyXzM0NW1fdjBfMC56aXA=",highlighted:`wget --content-disposition https://api.ngc.nvidia.com/v2/models/nvidia/megatron_lm_345m/versions/v0.0/zip -O
megatron_gpt2_345m_v0_0.zip`}}),O=new vt({props:{code:"cHl0aG9uMyUyMCUyNFBBVEhfVE9fVFJBTlNGT1JNRVJTJTJGbW9kZWxzJTJGbWVnYXRyb25fZ3B0MiUyRmNvbnZlcnRfbWVnYXRyb25fZ3B0Ml9jaGVja3BvaW50LnB5JTIwbWVnYXRyb25fZ3B0Ml8zNDVtX3YwXzAuemlw",highlighted:'python3 <span class="hljs-variable">$PATH_TO_TRANSFORMERS</span>/models/megatron_gpt2/convert_megatron_gpt2_checkpoint.py megatron_gpt2_345m_v0_0.zip'}}),{c(){g=n("meta"),Z=c(),v=n("h1"),w=n("a"),V=n("span"),fe(P.$$.fragment),we=c(),z=n("span"),Te=r("MegatronGPT2"),X=c(),y=n("h2"),T=n("a"),x=n("span"),fe(M.$$.fragment),_e=c(),F=n("span"),be=r("Overview"),j=c(),_=n("p"),Pe=r("The MegatronGPT2 model was proposed in "),E=n("a"),Me=r(`Megatron-LM: Training Multi-Billion Parameter Language Models Using Model
Parallelism`),Ee=r(` by Mohammad Shoeybi, Mostofa Patwary, Raul Puri, Patrick LeGresley,
Jared Casper and Bryan Catanzaro.`),Y=c(),L=n("p"),Ge=r("The abstract from the paper is the following:"),Q=c(),B=n("p"),H=n("em"),Ae=r(`Recent work in language modeling demonstrates that training large transformer models advances the state of the art in
Natural Language Processing applications. However, very large models can be quite difficult to train due to memory
constraints. In this work, we present our techniques for training very large transformer models and implement a simple,
efficient intra-layer model parallel approach that enables training transformer models with billions of parameters. Our
approach does not require a new compiler or library changes, is orthogonal and complimentary to pipeline model
parallelism, and can be fully implemented with the insertion of a few communication operations in native PyTorch. We
illustrate this approach by converging transformer based models up to 8.3 billion parameters using 512 GPUs. We sustain
15.1 PetaFLOPs across the entire application with 76% scaling efficiency when compared to a strong single GPU baseline
that sustains 39 TeraFLOPs, which is 30% of peak FLOPs. To demonstrate that large language models can further advance
the state of the art (SOTA), we train an 8.3 billion parameter transformer language model similar to GPT-2 and a 3.9
billion parameter model similar to BERT. We show that careful attention to the placement of layer normalization in
BERT-like models is critical to achieving increased performance as the model size grows. Using the GPT-2 model we
achieve SOTA results on the WikiText103 (10.8 compared to SOTA perplexity of 15.8) and LAMBADA (66.5% compared to SOTA
accuracy of 63.2%) datasets. Our BERT model achieves SOTA results on the RACE dataset (90.9% compared to SOTA accuracy
of 89.4%).`),K=c(),J=n("p"),ke=r("Tips:"),ee=c(),b=n("p"),$e=r("We have provided pretrained "),G=n("a"),Oe=r("GPT2-345M"),Ce=r(` checkpoints
for use to evaluate or finetuning downstream tasks.`),te=c(),f=n("p"),Ne=r("To access these checkpoints, first "),A=n("a"),Le=r("sign up"),Be=r(` for and setup the NVIDIA GPU Cloud (NGC)
Registry CLI. Further documentation for downloading models can be found in the `),k=n("a"),Je=r("NGC documentation"),Re=r("."),ae=c(),R=n("p"),Se=r("Alternatively, you can directly download the checkpoints using:"),oe=c(),fe($.$$.fragment),ne=c(),S=n("p"),We=r(`Once you have obtained the checkpoint from NVIDIA GPU Cloud (NGC), you have to convert it to a format that will easily
be loaded by Hugging Face Transformers GPT2 implementation.`),re=c(),h=n("p"),Ie=r("The following command allows you to do the conversion. We assume that the folder "),q=n("code"),Ue=r("models/megatron_gpt2"),Ve=r(` contains
`),D=n("code"),ze=r("megatron_gpt2_345m_v0_0.zip"),xe=r(" and that the command is run from that folder:"),le=c(),fe(O.$$.fragment),ie=c(),u=n("p"),Fe=r("This model was contributed by "),C=n("a"),He=r("jdemouth"),qe=r(". The original code can be found "),N=n("a"),De=r("here"),Ze=r(`. That repository contains a multi-GPU and multi-node implementation of the
Megatron Language models. In particular, it contains a hybrid model parallel approach using \u201Ctensor parallel\u201D and
\u201Cpipeline parallel\u201D techniques.`),this.h()},l(e){const o=_t('[data-svelte="svelte-1phssyn"]',document.head);g=l(o,"META",{name:!0,content:!0}),o.forEach(t),Z=d(e),v=l(e,"H1",{class:!0});var me=s(v);w=l(me,"A",{id:!0,class:!0,href:!0});var je=s(w);V=l(je,"SPAN",{});var Ye=s(V);he(P.$$.fragment,Ye),Ye.forEach(t),je.forEach(t),we=d(me),z=l(me,"SPAN",{});var Qe=s(z);Te=i(Qe,"MegatronGPT2"),Qe.forEach(t),me.forEach(t),X=d(e),y=l(e,"H2",{class:!0});var pe=s(y);T=l(pe,"A",{id:!0,class:!0,href:!0});var Ke=s(T);x=l(Ke,"SPAN",{});var et=s(x);he(M.$$.fragment,et),et.forEach(t),Ke.forEach(t),_e=d(pe),F=l(pe,"SPAN",{});var tt=s(F);be=i(tt,"Overview"),tt.forEach(t),pe.forEach(t),j=d(e),_=l(e,"P",{});var ce=s(_);Pe=i(ce,"The MegatronGPT2 model was proposed in "),E=l(ce,"A",{href:!0,rel:!0});var at=s(E);Me=i(at,`Megatron-LM: Training Multi-Billion Parameter Language Models Using Model
Parallelism`),at.forEach(t),Ee=i(ce,` by Mohammad Shoeybi, Mostofa Patwary, Raul Puri, Patrick LeGresley,
Jared Casper and Bryan Catanzaro.`),ce.forEach(t),Y=d(e),L=l(e,"P",{});var ot=s(L);Ge=i(ot,"The abstract from the paper is the following:"),ot.forEach(t),Q=d(e),B=l(e,"P",{});var nt=s(B);H=l(nt,"EM",{});var rt=s(H);Ae=i(rt,`Recent work in language modeling demonstrates that training large transformer models advances the state of the art in
Natural Language Processing applications. However, very large models can be quite difficult to train due to memory
constraints. In this work, we present our techniques for training very large transformer models and implement a simple,
efficient intra-layer model parallel approach that enables training transformer models with billions of parameters. Our
approach does not require a new compiler or library changes, is orthogonal and complimentary to pipeline model
parallelism, and can be fully implemented with the insertion of a few communication operations in native PyTorch. We
illustrate this approach by converging transformer based models up to 8.3 billion parameters using 512 GPUs. We sustain
15.1 PetaFLOPs across the entire application with 76% scaling efficiency when compared to a strong single GPU baseline
that sustains 39 TeraFLOPs, which is 30% of peak FLOPs. To demonstrate that large language models can further advance
the state of the art (SOTA), we train an 8.3 billion parameter transformer language model similar to GPT-2 and a 3.9
billion parameter model similar to BERT. We show that careful attention to the placement of layer normalization in
BERT-like models is critical to achieving increased performance as the model size grows. Using the GPT-2 model we
achieve SOTA results on the WikiText103 (10.8 compared to SOTA perplexity of 15.8) and LAMBADA (66.5% compared to SOTA
accuracy of 63.2%) datasets. Our BERT model achieves SOTA results on the RACE dataset (90.9% compared to SOTA accuracy
of 89.4%).`),rt.forEach(t),nt.forEach(t),K=d(e),J=l(e,"P",{});var lt=s(J);ke=i(lt,"Tips:"),lt.forEach(t),ee=d(e),b=l(e,"P",{});var de=s(b);$e=i(de,"We have provided pretrained "),G=l(de,"A",{href:!0,rel:!0});var it=s(G);Oe=i(it,"GPT2-345M"),it.forEach(t),Ce=i(de,` checkpoints
for use to evaluate or finetuning downstream tasks.`),de.forEach(t),te=d(e),f=l(e,"P",{});var W=s(f);Ne=i(W,"To access these checkpoints, first "),A=l(W,"A",{href:!0,rel:!0});var st=s(A);Le=i(st,"sign up"),st.forEach(t),Be=i(W,` for and setup the NVIDIA GPU Cloud (NGC)
Registry CLI. Further documentation for downloading models can be found in the `),k=l(W,"A",{href:!0,rel:!0});var mt=s(k);Je=i(mt,"NGC documentation"),mt.forEach(t),Re=i(W,"."),W.forEach(t),ae=d(e),R=l(e,"P",{});var pt=s(R);Se=i(pt,"Alternatively, you can directly download the checkpoints using:"),pt.forEach(t),oe=d(e),he($.$$.fragment,e),ne=d(e),S=l(e,"P",{});var ct=s(S);We=i(ct,`Once you have obtained the checkpoint from NVIDIA GPU Cloud (NGC), you have to convert it to a format that will easily
be loaded by Hugging Face Transformers GPT2 implementation.`),ct.forEach(t),re=d(e),h=l(e,"P",{});var I=s(h);Ie=i(I,"The following command allows you to do the conversion. We assume that the folder "),q=l(I,"CODE",{});var dt=s(q);Ue=i(dt,"models/megatron_gpt2"),dt.forEach(t),Ve=i(I,` contains
`),D=l(I,"CODE",{});var ft=s(D);ze=i(ft,"megatron_gpt2_345m_v0_0.zip"),ft.forEach(t),xe=i(I," and that the command is run from that folder:"),I.forEach(t),le=d(e),he(O.$$.fragment,e),ie=d(e),u=l(e,"P",{});var U=s(u);Fe=i(U,"This model was contributed by "),C=l(U,"A",{href:!0,rel:!0});var ht=s(C);He=i(ht,"jdemouth"),ht.forEach(t),qe=i(U,". The original code can be found "),N=l(U,"A",{href:!0,rel:!0});var ut=s(N);De=i(ut,"here"),ut.forEach(t),Ze=i(U,`. That repository contains a multi-GPU and multi-node implementation of the
Megatron Language models. In particular, it contains a hybrid model parallel approach using \u201Ctensor parallel\u201D and
\u201Cpipeline parallel\u201D techniques.`),U.forEach(t),this.h()},h(){p(g,"name","hf:doc:metadata"),p(g,"content",JSON.stringify(Et)),p(w,"id","megatrongpt2"),p(w,"class","header-link text-lg hidden group-hover:block absolute right-full p-1.5"),p(w,"href","#megatrongpt2"),p(v,"class","relative group"),p(T,"id","overview"),p(T,"class","header-link text-lg hidden group-hover:block absolute right-full p-1.5"),p(T,"href","#overview"),p(y,"class","relative group"),p(E,"href","https://arxiv.org/abs/1909.08053"),p(E,"rel","nofollow"),p(G,"href","https://ngc.nvidia.com/catalog/models/nvidia:megatron_lm_345m"),p(G,"rel","nofollow"),p(A,"href","https://ngc.nvidia.com/signup"),p(A,"rel","nofollow"),p(k,"href","https://docs.nvidia.com/dgx/ngc-registry-cli-user-guide/index.html#topic_6_4_1"),p(k,"rel","nofollow"),p(C,"href","https://huggingface.co/jdemouth"),p(C,"rel","nofollow"),p(N,"href","https://github.com/NVIDIA/Megatron-LM"),p(N,"rel","nofollow")},m(e,o){a(document.head,g),m(e,Z,o),m(e,v,o),a(v,w),a(w,V),ue(P,V,null),a(v,we),a(v,z),a(z,Te),m(e,X,o),m(e,y,o),a(y,T),a(T,x),ue(M,x,null),a(y,_e),a(y,F),a(F,be),m(e,j,o),m(e,_,o),a(_,Pe),a(_,E),a(E,Me),a(_,Ee),m(e,Y,o),m(e,L,o),a(L,Ge),m(e,Q,o),m(e,B,o),a(B,H),a(H,Ae),m(e,K,o),m(e,J,o),a(J,ke),m(e,ee,o),m(e,b,o),a(b,$e),a(b,G),a(G,Oe),a(b,Ce),m(e,te,o),m(e,f,o),a(f,Ne),a(f,A),a(A,Le),a(f,Be),a(f,k),a(k,Je),a(f,Re),m(e,ae,o),m(e,R,o),a(R,Se),m(e,oe,o),ue($,e,o),m(e,ne,o),m(e,S,o),a(S,We),m(e,re,o),m(e,h,o),a(h,Ie),a(h,q),a(q,Ue),a(h,Ve),a(h,D),a(D,ze),a(h,xe),m(e,le,o),ue(O,e,o),m(e,ie,o),m(e,u,o),a(u,Fe),a(u,C),a(C,He),a(u,qe),a(u,N),a(N,De),a(u,Ze),se=!0},p:bt,i(e){se||(ge(P.$$.fragment,e),ge(M.$$.fragment,e),ge($.$$.fragment,e),ge(O.$$.fragment,e),se=!0)},o(e){ve(P.$$.fragment,e),ve(M.$$.fragment,e),ve($.$$.fragment,e),ve(O.$$.fragment,e),se=!1},d(e){t(g),e&&t(Z),e&&t(v),ye(P),e&&t(X),e&&t(y),ye(M),e&&t(j),e&&t(_),e&&t(Y),e&&t(L),e&&t(Q),e&&t(B),e&&t(K),e&&t(J),e&&t(ee),e&&t(b),e&&t(te),e&&t(f),e&&t(ae),e&&t(R),e&&t(oe),ye($,e),e&&t(ne),e&&t(S),e&&t(re),e&&t(h),e&&t(le),ye(O,e),e&&t(ie),e&&t(u)}}}const Et={local:"megatrongpt2",sections:[{local:"overview",title:"Overview"}],title:"MegatronGPT2"};function Gt(Xe){return Pt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ot extends yt{constructor(g){super();wt(this,g,Gt,Mt,Tt,{})}}export{Ot as default,Et as metadata};
